#coding:utf-8
from abc import ABCMeta, abstractmethod
import json
import traceback


class AbstractHandler(object):
    """
    Абстрактный обработчик очереди сообщений
    """
    __metaclass__ = ABCMeta

    def __init__(self, clients):
        self.clients = clients

    @abstractmethod
    def send(self, message_obj):
        pass

    def bind(self, body):
        try:
            obj = json.loads(body)
            self.send(obj)
        except Exception as e:
            traceback.print_exc(e)
