#coding:utf-8
import functools
from msgserver.utils.tornadoasyncmemcache import Client

class AsyncSessions(object):
    """
    Ассинхронный доступ к django-сессиям хранящимся в Memcached
    """
    def __init__(self, params):
        cache_host = params.get('cache_host')
        if not cache_host.startswith('memcached'):
            raise Exception('Incorrect cache engine!')
        memcache_host = cache_host.replace('memcached://', '').replace('/', '')
        self.client = Client([memcache_host], debug=1)

    def get_user_id(self, session_id, callback):
        """
        Работает исключительно в связке с
            'django.contrib.sessions.middleware.SessionMiddleware',
            'django.contrib.auth.middleware.AuthenticationMiddleware',
            и
            'django.contrib.sessions.backends.cache'
        """
        key = ':1:%s' % session_id
        on_response_callback = functools.partial(self._on_db_response, callback)
        self.client.get(key, on_response_callback)

    def _on_db_response(self, callback, session_data):
        #print 'Session data:', session_data
        if session_data:
            session = session_data
            callback(session.get('_auth_user_id'))
