#coding:utf-8
from sockjs.tornado import SockJSConnection, SockJSRouter


class SessionSockJSConnection(SockJSConnection):
    """
    Сессионное подключение через SockJS. Знает о django-сессии и пользователе
    """
    clients = set()
    cookie_session_key = 'sessionid'

    def __init__(self, session):
        super(SessionSockJSConnection, self).__init__(session)
        self.user_id = None
        self.session_id = None

    def on_open(self, request):
        # считаем куки и django-сессию из них
        self.session_id = request.cookies.get(self.cookie_session_key).value
        # также достанем ID пользователя
        self.session_engine.get_user_id(self.session_id, self.set_user_id)
        self.clients.add(self)

    def set_user_id(self, user_id):
        self.user_id = user_id
        #print 'User id:', self.user_id

    def on_close(self):
        self.clients.remove(self)

    @classmethod
    def create_router(cls, socket_url, session_engine, cookie_session_key):
        cls.cookie_session_key = cookie_session_key
        cls.session_engine = session_engine
        return SockJSRouter(cls, socket_url)